Module parameters

! 01/06/2021 : Variable explanations and a continuous version of simulation are attached.
    
! parameter.f90 takes a role for assinging parameters to the model.
        
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Variables explanation !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! soltype : type of solution method, 1 = GEGM, 2=Grid Search Method
! pricetype : type of the price updating, 1 = continuous, 2= on the grid points
! gridtype : type of grid on b (assets) for solving the values, 1 = linear grid, 2=log-scaled grid, 3= double log-sclaed grid
! Nb : # of grid on b for computing the values
! nNb : # of grid for b=<0 in computing the values
! pNb : # of grid for b>=0 in computing the values
! gridmutype : type of grid on b in computing the distribution
! Nbmu : # of grid in computing the distribution
! nNbmu : # of grid for b=<0 in computing the distribution
! pNbmu : # of grid for b>=0 in computing the distribution
! Nsim : the final period of simulations
! spline : type of spline for the expected values, spline=1=> linear interpolation, spline2=>cubic spline
! sigy : std of shocks on y
! muy : mean of y 
! rhoy : persistence of shocks on y
! mstdy : range of the approximation of shocks on y=> -2.5 * stdy to 2.5 * stdy
! eps : values and price covergence criterion
! expy : the scale parameter for b, followed by Arelleno (2008)
! risksigz: Coefficient of risk aversion parameter
! rf : world risk-free interest rate
! beta : discount factor
! ybar : thresholds of the output penalty in autarky.
! lbb : lower bound of the grids on b
! ubb : upper bound of the grids on b
! theta : prob of preserving autarky status in the next period.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

Integer, parameter :: soltype=1, pricetype=1, gridtype=2, Nb=200, nNb=100, pNb=101
Integer, parameter :: gridmutype=2, Nbmu=2000, nNbmu=1000, pNbmu=1001
Integer, parameter :: Nsim=100000, spline=1 
Integer, parameter :: Ny=21, bnotsb=Nb-2, ynotsy=Ny-2, deriv=1 ! RIGHT derivative
Real(8), parameter :: sigy=0.0250d0, muy=0.0d0,rhoy=0.9450d0, mstdy=2.50d0
Real(8), parameter :: eps=1d-5, expy=10.0d0
Real(8), parameter :: risksig=2.0d0, rf=1.0170d0, beta=0.952820d0,ybar=0.9690d0*expy
Real(8), parameter :: lbb=-2.50d0, ubb=3.50d0,scale=1.50d0
Real(8), parameter :: theta=0.2820d0

End module parameters