Program main
    
! 01/06/2021 : Variable explanations and a continuous version of simulation are attached.
    
! main.f90 is the main part of the codes
    
use parameters
use comp_libs
use inner
use omp_lib

Implicit none

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Variables explanation !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! bprice: matrix for loan price schedules
! Vd: value for defaulting
! gb: decision rule for b'
! Mval: max(Vr,Vd) where Vr is repaying value function
! bgrid: grid for b
! proy: probability of y to y'
! yst: stataionary probability of y
! endow: grid for y
! gd: decision rule for default
! gc: decision rule for consumption
! qb: matrix for the discounted value of loans q(b',S)*b'
! Dqb: matrix for the derivative of qb

Real(8), allocatable :: bprice(:,:), Vd(:), gb(:,:), Mval(:,:)
Real(8), allocatable :: bgrid(:), proy(:,:), yst(:), endow(:)
Real(8), allocatable :: gd(:,:),gc(:,:)
Real(8), allocatable :: qb(:,:), Dqb(:,:)


Real(8), allocatable :: tempmt(:,:), valb1(:),valb2(:)
Real(8) :: aaa,bbb,vep1, vep2, diffprice
Integer :: zerocap,ind_b1, ind_b2, ind_y1, ind_y2, iter,i1,i2,j1,j2,seqnum,onlysim
Integer(8) :: starting, cra, cma, ending 
Character :: hem, qbseq


! variables for Ballman equation erros and 
Real(8), allocatable :: simb(:), simcons(:), simdef(:),iidseed(:),simerr(:),simerrb(:)
Real(8), allocatable :: simy(:), simqb(:),simprice(:),simdata(:,:), simindex(:),simcredit(:)
real(8) :: g(nbmu+1,ny),bellman(nbmu,ny),averr,maxerr,minerr,g0(nbmu+1,ny),bgridmu(nbmu),gbmu(nbmu,ny)
real(8) :: bpmu(nbmu,ny),gcmu(nbmu,ny),gdmu(nbmu,ny),mvmu(nbmu,ny)
integer :: zbmu,iii(nbmu)


call system_clock ( starting, cra)

allocate(bprice(Nb,Ny),Vd(Ny),&
    &gb(Nb,Ny), Mval(Nb,Ny),&
    &bgrid(Nb),proy(Ny,Ny),yst(Ny),valb1(Nb),valb2(Nb),&
    &endow(Ny),gc(Nb,Ny),gd(Nb,Ny),&
    &simb(Nsim), simcons(Nsim), simdef(Nsim),simindex(Nsim),&
    &simcredit(Nsim),simy(Nsim), simqb(Nsim),simprice(Nsim),&
    &iidseed(Nsim),qb(Nb,Ny),Dqb(Nb,Ny))


!!!!!!!!!!!!!!!!!!!!!!! Set up the grid and probability of endowment y !!!!!!!!!
call gen_Tauchen (Ny, muy,rhoy, sigy, mstdy, proy, endow)
endow=endow*expy



!!!!!!!!!!!!!!!!!!!!!! Save the index for 0 bond (zerocap)!!!!!!!!!!!!!!!!!!!!!
call gridroutine(gridtype,nnb,pnb,lbb,ubb,bgrid)
!print*, bgrid
aaa=0.0d0
call gridlookup(bnotsb,bgrid,aaa,zerocap)


call gridroutine(gridmutype,nnbmu,pnbmu,lbb,ubb,bgridmu)
iii = bgridmu.le.0.0d0
zbmu = -sum( iii  )
print*, zbmu
print*, bgridmu(zbmu)



!onlysim=0
!
!If (onlysim==0) then

!!!!!!!!!!!!!!!!!!!! Solving the values !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
call Endgrid(zerocap,proy,endow,bgrid,bprice,gb,gc,gd,Vd,Mval)
      

open (unit=19,file="bprice.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") bprice(:,ind_y1)
end do
close(19)

open (unit=19,file="gb.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") gb(:,ind_y1)
end do
close(19)

open (unit=19,file="gc.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") gc(:,ind_y1)
end do
close(19)

open (unit=19,file="gd.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") gd(:,ind_y1)
end do
close(19)

open (unit=19,file="vd.csv",action="write",status="replace")  
    write (19,"(20000(f0.8,',',:))") vd
close(19)

open (unit=19,file="Mval.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") Mval(:,ind_y1)
end do
close(19)


g0 = 0.0d0

do ind_y1 = 1,ny
g0(zbmu+1,ind_y1) = 1.0d0/dble(ny)
end do

g0 = g0/sum(g0)

!!!!!!!!!!!!!!!!!!!!!!!! Computing the distribution without any simulation !!!!!!!!!!!!!!!!!!!!!!!!!!!
call distribution(g0,zbmu,bgrid,bprice,gb,gc,gd,Vd,Mval,proy,endow,bgridmu,bpmu,gbmu,gcmu,gdmu,mvmu,g)

open (unit=19,file="bpmu.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") bpmu(:,ind_y1)
end do
close(19)

open (unit=19,file="gbmu.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") gbmu(:,ind_y1)
end do
close(19)

open (unit=19,file="gcmu.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") gcmu(:,ind_y1)
end do
close(19)

open (unit=19,file="gdmu.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") gdmu(:,ind_y1)
end do
close(19)

open (unit=19,file="mvmu.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") mvmu(:,ind_y1)
end do
close(19)

open (unit=19,file="g.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") g(:,ind_y1)
end do
close(19)
!
!!! bellman error
call bellmanerror(zbmu,Vd,proy,endow,bgridmu,bpmu,gbmu,gcmu,gdmu,mvmu,g,bellman,averr,maxerr,minerr)

open (unit=19,file="bellman.csv",action="write",status="replace")  
Do ind_y1=1,Ny
    write (19,"(20000(f0.8,',',:))") bellman(:,ind_y1)
end do
close(19)

open (unit=19,file="error.csv",action="write",status="replace")  
    write (19,"(20000(f0.8,',',:))") averr
    write (19,"(20000(f0.8,',',:))") minerr
    write (19,"(20000(f0.8,',',:))") maxerr
close(19)

!call simul(Nsim,Ny,proy,11,5,simindex)

!Call random_number(iidseed)

!open (unit=19,file="markovseed.csv",action="write",status="replace")  
!    write (19,"(20000(i0.8,',',:))") simindex
!close(19)

!open (unit=19,file="iidseed.csv",action="write",status="replace")  
!    write (19,"(20000(f0.8,',',:))") iidseed
!close(19)


!open (unit=19,file="markovseed.csv",status="old")   
!        read (19,*) simindex
!close(19)
!
!open (unit=19,file="iidseed.csv",status="old")   
!        read (19,*) iidseed
!close(19)
!
!
!Do ind_y1=1,Ny
!    qb(:,ind_y1)=bprice(:,ind_y1)*bgrid
!    valb1=qb(:,ind_y1)
!    call numderiv(bnotsb,bgrid,valb1,valb2,deriv)
!    Dqb(:,ind_y1)=valb2
!end do
!   
!
!call simulation(zerocap,simindex,iidseed,bgrid,endow,bprice,qb,Dqb,gb,gc,gd,simy,simb,simprice,simqb,simcons,simdef,simcredit)
!
!allocate(simdata(7,Nsim))
!
!simdata(1,:)=simy
!simdata(2,:)=simb
!simdata(3,:)=simprice
!simdata(4,:)=simqb
!simdata(5,:)=simcons
!simdata(6,:)=simdef
!simdata(7,:)=real(simcredit)
!
!open (unit=19,file="simdata.csv",action="write",status="replace")   
!    Do i1=1,Nsim
!        write (19,"(20000(f0.8,',',:))") simdata(:,i1)
!    end do
!close(19)
!
!
!
!
!
!seqnum=0
!Do i1=1,Nsim-1
!    If ((simcredit(i1)==1).and.(simcredit(i1+1)==1)) then
!        seqnum=seqnum+1
!    end if
!end do
!
!allocate(simerr(seqnum),simerrb(seqnum))
!
!
!call Eulererr(seqnum,simindex,proy,simcons,simb,simcredit,endow,bprice,qb,gb,gc,Dqb,bgrid,simerr,simerrb,averr,maxerr)
!
!print*, averr, maxerr
!
!open (unit=19,file="averr.csv",action="write",status="replace")   
!    write (19,"(20000(f0.8,',',:))") averr
!close(19)
!
!open (unit=19,file="maxerr.csv",action="write",status="replace")   
!    write (19,"(20000(f0.8,',',:))") maxerr
!close(19)
!
!
!open (unit=19,file="simerr.csv",action="write",status="replace") 
!Do i1=1,seqnum
!    write (19,"(20000(f0.8,',',:))") simerr(i1)
!end do
!close(19)
!
!open (unit=19,file="simerrb.csv",action="write",status="replace")
!Do i1=1,seqnum
!    write (19,"(20000(f0.8,',',:))") simerrb(i1)
!end do
!close(19)


!else if (onlysim==1) then
!
!open (unit=19,file="markovseed.csv",status="old")   
!        read (19,*) simindex
!close(19)
!open (unit=19,file="iidseed.csv",status="old")   
!        read (19,*) iidseed
!close(19)
!
!    
!open (unit=19,file="bprice.csv",status="old")  
!Do ind_y1=1,Ny
!    read (19,*) bprice(:,ind_y1)
!end do
!close(19)
!
!Do ind_y1=1,Ny
!    qb(:,ind_y1)=bprice(:,ind_y1)*bgrid
!    valb1=qb(:,ind_y1)
!    call numderiv(bnotsb,bgrid,valb1,valb2,deriv)
!    Dqb(:,ind_y1)=valb2
!end do
!
!open (unit=19,file="gb.csv",status="old")  
!Do ind_y1=1,Ny
!    read (19,*) gb(:,ind_y1)
!end do
!close(19)
!
!open (unit=19,file="gc.csv",status="old")  
!Do ind_y1=1,Ny
!    read (19,*) gc(:,ind_y1)
!end do
!close(19)
!
!open (unit=19,file="gd.csv",status="old")  
!Do ind_y1=1,Ny
!    read (19,*) gd(:,ind_y1)
!end do
!close(19)
!
!open (unit=19,file="vd.csv",status="old")  
!  read (19,*) vd
!close(19)
!
!open (unit=19,file="val.csv",status="old")  
!Do ind_y1=1,Ny
!    read (19,*) val(:,ind_y1)
!end do
!close(19)
!
!
!
! Do ind_y1=1,Ny
!    qb(:,ind_y1)=bprice(:,ind_y1)*bgrid
!    valb1=qb(:,ind_y1)
!    call numderiv(bnotsb,bgrid,valb1,valb2,deriv)
!    Dqb(:,ind_y1)=valb2
!end do
!   
!
!call simulation(zerocap,simindex,iidseed,bgrid,endow,bprice,qb,Dqb,gb,gc,gd,simy,simb,simprice,simqb,simcons,simdef,simcredit)
!
!allocate(simdata(7,Nsim))
!
!simdata(1,:)=simy
!simdata(2,:)=simb
!simdata(3,:)=simprice
!simdata(4,:)=simqb
!simdata(5,:)=simcons
!simdata(6,:)=simdef
!simdata(7,:)=real(simcredit)
!
!open (unit=19,file="simdata.csv",action="write",status="replace")   
!    Do i1=1,Nsim
!        write (19,"(20000(f0.8,',',:))") simdata(:,i1)
!    end do
!close(19)
!
!
!
!seqnum=0
!Do i1=1,Nsim-1
!    If ((simcredit(i1)==1).and.(simcredit(i1+1)==1)) then
!        seqnum=seqnum+1
!    end if
!end do
!
!allocate(simerr(seqnum),simerrb(seqnum))
!
!
!call Eulererr(seqnum,simindex,proy,simcons,simb,simcredit,endow,bprice,qb,gb,gc,Dqb,bgrid,simerr,simerrb,averr,maxerr)
!
!print*, averr, maxerr
!
!open (unit=19,file="averr.csv",action="write",status="replace")   
!    write (19,"(20000(f0.8,',',:))") averr
!close(19)
!
!open (unit=19,file="maxerr.csv",action="write",status="replace")   
!    write (19,"(20000(f0.8,',',:))") maxerr
!close(19)
!
!
!open (unit=19,file="simerr.csv",action="write",status="replace") 
!Do i1=1,seqnum
!    write (19,"(20000(f0.8,',',:))") simerr(i1)
!end do
!close(19)
!
!open (unit=19,file="simerrb.csv",action="write",status="replace")
!Do i1=1,seqnum
!    write (19,"(20000(f0.8,',',:))") simerrb(i1)
!end do
!close(19)
!
!
!end if
    




End program main





    